/*
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4457 $
 * $LastChangedDate:: 2026-08-13 18:59:23 +0200#$
 */
/* USERCODE-BEGIN:Description */
/* Description: */
/* USERCODE-END:Description */

package at.lcm.x2c.library.general;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_LookupTable1D_Float32_RAM extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble TableDataMaskVal = (MaskDouble)this.getMaskParameter("TableData").getMaskDataType();
        TNumeric TableDataMaskData = (TNumeric)TableDataMaskVal.getData();
        double mp_TableData = TableDataMaskData.getReal(0, 0);
        MaskComboBox DimXMaskVal = (MaskComboBox)this.getMaskParameter("DimX").getMaskDataType();
        TString DimXMaskData = (TString)DimXMaskVal.getData();
        String mp_DimX = DimXMaskData.getString();
        MaskDouble x_minMaskVal = (MaskDouble)this.getMaskParameter("x_min").getMaskDataType();
        TNumeric x_minMaskData = (TNumeric)x_minMaskVal.getData();
        double mp_x_min = x_minMaskData.getReal(0, 0);
        MaskDouble x_maxMaskVal = (MaskDouble)this.getMaskParameter("x_max").getMaskDataType();
        TNumeric x_maxMaskData = (TNumeric)x_maxMaskVal.getData();
        double mp_x_max = x_maxMaskData.getReal(0, 0);

        TNumeric TableCtrVal = this.getImplementationParameterData("Table");
        double[] cp_Table = new double[257];
        cp_Table[0] = Double.NaN;
        TNumeric dimXCtrVal = this.getImplementationParameterData("dimX");
        double cp_dimX = Double.NaN;
        TNumeric gainXCtrVal = this.getImplementationParameterData("gainX");
        double cp_gainX = Double.NaN;
        TNumeric offsetXCtrVal = this.getImplementationParameterData("offsetX");
        double cp_offsetX = Double.NaN;

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_TableData OR TableDataMaskVal (Number) */
        /* mp_DimX OR DimXMaskVal (String) */
        /* mp_x_min OR x_minMaskVal (Number) */
        /* mp_x_max OR x_maxMaskVal (Number) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
        final int size_x;
        final int SIZE_ROW = 1;
        final int MAX_DIM = 257;
        double x_min, x_max, offsetX, gainX;

        /* get table size */
        size_x = Integer.valueOf(DimXMaskVal.getValue());

        /* check selected table size */
        if (size_x > MAX_DIM) {
            throw new Exception("DimX must not be greater than " + MAX_DIM + " for RAM-Table implementation of this block!");
        }

        /* check table data for correct size */
        if ((TableDataMaskData.getNumColumns() != size_x) || (TableDataMaskData.getNumRows() != SIZE_ROW)) {
            throw new Exception("Lookup Table Size mismatch in column: expected=(" + SIZE_ROW + ", " + size_x + ") " + "got=("
                    + TableDataMaskData.getNumRows() + "," + TableDataMaskData.getNumColumns() + ")");
        }

        /* convert dimension value */
        dimXCtrVal.setReal(0, 0, size_x - 1);

        /* convert input scaling */
        x_min = Double.valueOf(x_minMaskVal.getValue());
        x_max = Double.valueOf(x_maxMaskVal.getValue());
        if (x_min >= x_max) {
            throw new Exception("Scaling of x-dimension not possible: x_max must be greater than x_min!)");
        }
        offsetX = x_min;
        gainX = (size_x - 1) / (x_max - x_min);
        offsetXCtrVal.setReal(0, 0, offsetX);
        gainXCtrVal.setReal(0, 0, gainX);

        /* convert table data */
        double[] tmpData = new double[MAX_DIM];
        for (int i = 0; i < size_x; i++) {
            tmpData[i] = TableDataMaskData.getReal(0, i);
        }

        /* fill unused remaining data with zeroes */
        for (int i = size_x; i < MAX_DIM; i++) {
            tmpData[i] = 0.0d;
        }

        TableCtrVal = new TNumeric(tmpData);
        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_Table OR TableCtrVal (RAM array) */
        /* cp_dimX OR dimXCtrVal (Value) */
        /* cp_gainX OR gainXCtrVal (Value) */
        /* cp_offsetX OR offsetXCtrVal (Value) */

        if (Double.isNaN(cp_Table[0])) {
            this.setImplementationParameterData("Table", TableCtrVal);
        } else {
            this.setImplementationParameterData("Table", new TNumeric(cp_Table));
        }
        if (Double.isNaN(cp_dimX)) {
            this.setImplementationParameterData("dimX", dimXCtrVal);
        } else {
            this.setImplementationParameterData("dimX", new TNumeric(cp_dimX));
        }
        if (Double.isNaN(cp_gainX)) {
            this.setImplementationParameterData("gainX", gainXCtrVal);
        } else {
            this.setImplementationParameterData("gainX", new TNumeric(cp_gainX));
        }
        if (Double.isNaN(cp_offsetX)) {
            this.setImplementationParameterData("offsetX", offsetXCtrVal);
        } else {
            this.setImplementationParameterData("offsetX", new TNumeric(cp_offsetX));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble TableDataMaskVal = (MaskDouble)this.getMaskParameter("TableData").getMaskDataType();
        TNumeric TableDataMaskData = (TNumeric)TableDataMaskVal.getData();
        double mp_TableData = Double.NaN;
        MaskComboBox DimXMaskVal = (MaskComboBox)this.getMaskParameter("DimX").getMaskDataType();
        TString DimXMaskData = (TString)DimXMaskVal.getData();
        String mp_DimX = null;
        MaskDouble x_minMaskVal = (MaskDouble)this.getMaskParameter("x_min").getMaskDataType();
        TNumeric x_minMaskData = (TNumeric)x_minMaskVal.getData();
        double mp_x_min = Double.NaN;
        MaskDouble x_maxMaskVal = (MaskDouble)this.getMaskParameter("x_max").getMaskDataType();
        TNumeric x_maxMaskData = (TNumeric)x_maxMaskVal.getData();
        double mp_x_max = Double.NaN;

        TNumeric TableCtrVal = this.getImplementationParameterData("Table");
        double[] cp_Table = TableCtrVal.getRealMatrix().getColumn(0);
        TNumeric dimXCtrVal = this.getImplementationParameterData("dimX");
        double cp_dimX = dimXCtrVal.getReal(0, 0);
        TNumeric gainXCtrVal = this.getImplementationParameterData("gainX");
        double cp_gainX = gainXCtrVal.getReal(0, 0);
        TNumeric offsetXCtrVal = this.getImplementationParameterData("offsetX");
        double cp_offsetX = offsetXCtrVal.getReal(0, 0);

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_Table OR TableCtrVal (RAM array) */
        /* cp_dimX OR dimXCtrVal (Value) */
        /* cp_gainX OR gainXCtrVal (Value) */
        /* cp_offsetX OR offsetXCtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
        int dimX, size_x;
        double offsetX, gainX, x_min, x_max;

        /* get controller parameter */
        dimX = (int) dimXCtrVal.getReal(0, 0);
        offsetX = offsetXCtrVal.getReal(0, 0);
        gainX = gainXCtrVal.getReal(0, 0);

        /* calculate mask parameter */
        size_x = dimX + 1;
        x_min = offsetX;
        x_max = (dimX / gainX) + offsetX;

        /* convert only relevant table data */
        double[] tmpData = new double[size_x];
        for (int i = 0; i < size_x; i++) {
            tmpData[i] = TableCtrVal.getReal(0, i);
        }

        /* set mask parameter */
        TableDataMaskData = new TNumeric(tmpData);
        DimXMaskData = new TString(Integer.toString(size_x));
        x_minMaskData.setReal(0, 0, x_min);
        x_maxMaskData.setReal(0, 0, x_max);

        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_TableData OR TableDataMaskVal (Number) */
        /* mp_DimX OR DimXMaskVal (String) */
        /* mp_x_min OR x_minMaskVal (Number) */
        /* mp_x_max OR x_maxMaskVal (Number) */

        if (Double.isNaN(mp_TableData)) {
            this.getMaskParameter("TableData").setValue(TableDataMaskData.toFullString());
        } else {
            this.getMaskParameter("TableData").setValue(new TNumeric(mp_TableData).toFullString());
        }
        if (mp_DimX == null) {
            this.getMaskParameter("DimX").setValue(DimXMaskData.getString());
        } else {
            this.getMaskParameter("DimX").setValue(mp_DimX);
        }
        if (Double.isNaN(mp_x_min)) {
            this.getMaskParameter("x_min").setValue(x_minMaskData.toFullString());
        } else {
            this.getMaskParameter("x_min").setValue(new TNumeric(mp_x_min).toFullString());
        }
        if (Double.isNaN(mp_x_max)) {
            this.getMaskParameter("x_max").setValue(x_maxMaskData.toFullString());
        } else {
            this.getMaskParameter("x_max").setValue(new TNumeric(mp_x_max).toFullString());
        }
    }
}
